#include "ngpc.h"
#include "carthdr.h"
#include "library.h"
#include "gusrob.c" 

// forward reference prototypes
void CopySpriteAnim(u8 AnimNumber);



#define TILE_SPRITE (1) // first tile used for Sprite
#define SPR_SPRITE (0) // sprite number used for Sprite (also 1,2 and 3)

   int bing;
   int ud;
   int key;
   int InvCheck;
   int blip;
   u8 iLoop;
   u8 SpriteX;
   u8 SpriteY;
   u8 SpriteAnim;
   u8 SpriteBaseAnim;

void main()
{
   InitNGPC();
   SysSetSystemFont();

   SetBackgroundColour(RGB(0,0,0));
//   InstallTileSet(TileSet, sizeof(TileSet)/2);
   InstallTileSet(tutorial, sizeof(tutorial)/2);
   SetPalette(SPRITE_PLANE, 0, 0, RGB(10,10,5), RGB(15,0,0), RGB(0,0,0));
   SetPalette(SCR_1_PLANE, 0, 0, 0, 0, RGB(15,15,15));
   SetPalette(SCR_2_PLANE, 0, 0, RGB(15,15,15), RGB(0,15,0), RGB(0,0,15));
   LevelOne();
}


// copies the new animation onto the Sprites tiles.
void CopySpriteAnim(u8 AnimNumber)
{
   u8 i;
   u16 * TileRam = TILE_RAM;
   u16 * theSpriteAnim = (u16 *) Sprite_Tiles;

   TileRam += (TILE_SPRITE * 8);
   theSpriteAnim += (AnimNumber * 8);
   
   for (i = 0; i < 32; i ++)
   {
      TileRam[i] = *theSpriteAnim++;
   }
}

int LevelOne()
{
   ClearScreen(SCR_1_PLANE);
   ClearScreen(SCR_2_PLANE);
   key=1;
   PutTile(SCR_2_PLANE, 0, 2, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, 2, WallLeft);
   PutTile(SCR_2_PLANE, 0, 2, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 17, 2, WallRight);
   PutTile(SCR_2_PLANE, 0, 16, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, 16, WallLeft);
   PutTile(SCR_2_PLANE, 0, 17, 16, WallRight);
   PutTile(SCR_2_PLANE, 0, 1, 1, WallTopLeft);
   PutTile(SCR_2_PLANE, 0, 2, 1, BedTopLeft);
   PutTile(SCR_2_PLANE, 0, 1, 1, BedTopRight);
   PutTile(SCR_2_PLANE, 0, 1, 2, BedBottomLeft);
   PutTile(SCR_2_PLANE, 0, 2, 2, BedBottomRight);
   PutTile(SCR_2_PLANE, 0, 1, 17, WallBottomLeft);
   PutTile(SCR_2_PLANE, 0, 17, 1, WallTopRight);
   PutTile(SCR_2_PLANE, 0, 17, 17, WallBottomRight2);
   for(iLoop=3;iLoop<=15;iLoop++)
   {
   PutTile(SCR_2_PLANE, 0, iLoop, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, iLoop, WallLeft);
   PutTile(SCR_2_PLANE, 0, iLoop, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 17, iLoop, WallRight);
   }

   // initialise Sprite variables
   SpriteX = 63;
   SpriteY = 63;
   SpriteAnim = 0;
   SpriteBaseAnim = 0;
   
   // set the initial sprite up
   // Note that all 4 sprites are chained together so we only have to
   // move the first one and the rest follow :-)
   SetSprite(SPR_SPRITE, TILE_SPRITE, 0, SpriteX, SpriteY, 0);
   SetSprite(SPR_SPRITE+1, TILE_SPRITE+1, 1, 8, 0, 0);
   SetSprite(SPR_SPRITE+2, TILE_SPRITE+2, 1, -8, 8, 0);
   SetSprite(SPR_SPRITE+3, TILE_SPRITE+3, 1, 8, 0, 0);

   while (1)
   {
      if ((JOYPAD & J_LEFT) && (SpriteX > 10))
      {
	   if (InvCheck == 2) { }
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 2) key = 2;
         CopySpriteAnim(16+(SpriteAnim * 4));
         SpriteX -= 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1; // toggles anim 0->1->0 }
	}
	}
      else if ((JOYPAD & J_RIGHT) && (SpriteX < 126))
      {
	   if (InvCheck == 2) {}
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 2) key = 2;
         CopySpriteAnim(24+(SpriteAnim * 4));
         SpriteX += 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
      }
	}
      else if ((JOYPAD & J_UP) && (SpriteY > 10))
      {
	   if (InvCheck == 2) {
   ud = 3;
   ClearScreen(SCR_2_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 2, Arrow);
}
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 2) key = 2;
         CopySpriteAnim(8+(SpriteAnim * 4));
         SpriteY -= 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
	}
      }
      else if ((JOYPAD & J_DOWN) && (SpriteY < 125))
      {
	   if (InvCheck == 2) {
   ud = 2;
   ClearScreen(SCR_2_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 3, Arrow);
}
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 1) key = 2;
         CopySpriteAnim(0+(SpriteAnim * 4));
         SpriteY += 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
	}
      }
      else if ((JOYPAD & J_DOWN) && (SpriteY > 123 & SpriteX > 124 & SpriteX < 200))
      {
	   if (InvCheck == 2) {
   ud = 2;
   ClearScreen(SCR_2_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 3, Arrow);
}
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 1) key = 2;
	   LevelTwo();
	}
      }
      else if (JOYPAD & J_DOWN)
      {
	   if (InvCheck == 2) {
   ud = 2;
   ClearScreen(SCR_2_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 3, Arrow);
}
	   else {}
      }
      else if ((JOYPAD & J_A) && (SpriteX < 26 & SpriteY < 26))
      {

	   if (InvCheck == 2) {

	   if (ud == 3  && blip == 2) {
bing = 3;
blip = 9;
PrintString(SCR_1_PLANE, 0, 4, 9, "Selected Key.");
}
	   else {} 
         
}
	   else {
         ClearScreen(SCR_1_PLANE);
	   if (key == 2) { PrintString(SCR_1_PLANE, 0, 4, 9, "It's A Bed.");
         PrintString(SCR_1_PLANE, 0, 2, 10, "No Time To Rest."); }
 	   else if (bing == 3)  PrintString(SCR_1_PLANE, 0, 2, 6, "That won't work."); 
	   else { PrintString(SCR_1_PLANE, 0, 2, 9, "Picked up a Key.");
	   blip = 2; }

	}
      }

      else if (JOYPAD & J_A)
      {

	   if (InvCheck == 2) {

	   if (ud == 3  && blip == 2) {
bing = 3;
blip = 9;
PrintString(SCR_1_PLANE, 0, 4, 9, "Selected Key.");
}
	   else {} 
         
}
	   else {}
      }

	else if (JOYPAD & J_B) Inventory1();
      Sleep(3);
   }
}

int LevelTwo()
{
   ClearScreen(SCR_1_PLANE);
   ClearScreen(SCR_2_PLANE);
   
   PutTile(SCR_2_PLANE, 0, 2, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, 2, WallLeft);
   PutTile(SCR_2_PLANE, 0, 2, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 17, 2, WallRight);
   PutTile(SCR_2_PLANE, 0, 16, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 1, 16, WallLeft);
   PutTile(SCR_2_PLANE, 0, 17, 16, WallRight);
   PutTile(SCR_2_PLANE, 0, 1, 1, WallTopLeft);
   PutTile(SCR_2_PLANE, 0, 2, 1, BedTopLeft);
   PutTile(SCR_2_PLANE, 0, 1, 1, BedTopRight);
   PutTile(SCR_2_PLANE, 0, 1, 2, BedBottomLeft);
   PutTile(SCR_2_PLANE, 0, 2, 2, BedBottomRight);
   PutTile(SCR_2_PLANE, 0, 1, 17, WallBottomLeft);
   PutTile(SCR_2_PLANE, 0, 17, 1, WallTopRight);
   PutTile(SCR_2_PLANE, 0, 17, 17, WallBottomRight);
   PutTile(SCR_2_PLANE, 0, 17, 1, WallBottomRight2);
   for(iLoop=3;iLoop<=15;iLoop++)
   {
   PutTile(SCR_2_PLANE, 0, iLoop, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, iLoop, WallLeft);
   PutTile(SCR_2_PLANE, 0, iLoop, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 17, iLoop, WallRight);
   }

   // initialise Sprite variables
   SpriteX = 126;
   SpriteY = 12;
   SpriteAnim = 0;
   SpriteBaseAnim = 0;
   
   // set the initial sprite up
   // Note that all 4 sprites are chained together so we only have to
   // move the first one and the rest follow :-)
   SetSprite(SPR_SPRITE, TILE_SPRITE, 0, SpriteX, SpriteY, 0);
   SetSprite(SPR_SPRITE+1, TILE_SPRITE+1, 1, 8, 0, 0);
   SetSprite(SPR_SPRITE+2, TILE_SPRITE+2, 1, -8, 8, 0);
   SetSprite(SPR_SPRITE+3, TILE_SPRITE+3, 1, 8, 0, 0);

   while (1)
   {
      if ((JOYPAD & J_LEFT) && (SpriteX > 10))
      {
	   if (InvCheck == 2) { }
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 2) key = 2;
         CopySpriteAnim(16+(SpriteAnim * 4));
         SpriteX -= 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1; // toggles anim 0->1->0 }
	}
	}
      else if ((JOYPAD & J_RIGHT) && (SpriteX < 126))
      {
	   if (InvCheck == 2) {}
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 2) key = 2;
         CopySpriteAnim(24+(SpriteAnim * 4));
         SpriteX += 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
      }
	}
      else if ((JOYPAD & J_UP) && (SpriteY > 10))
      {
	   if (InvCheck == 2) {
   ud = 3;
   ClearScreen(SCR_2_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 2, Arrow);
}
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 2) key = 2;
         CopySpriteAnim(8+(SpriteAnim * 4));
         SpriteY -= 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
	}
      }
      else if ((JOYPAD & J_DOWN) && (SpriteY < 125))
      {
	   if (InvCheck == 2) {
   ud = 2;
   ClearScreen(SCR_2_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 3, Arrow);
}
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 1) key = 2;
         CopySpriteAnim(0+(SpriteAnim * 4));
         SpriteY += 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
	}
      }
      else if ((JOYPAD & J_UP) && (SpriteY < 12 & SpriteX > 124))
      {
	   if (InvCheck == 2) {
   ud = 2;
   ClearScreen(SCR_2_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 3, Arrow);
}
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 1) key = 2;
	   LevelOneReturn();
	}
      }
      else if (JOYPAD & J_DOWN)
      {
	   if (InvCheck == 2) {
   ud = 2;
   ClearScreen(SCR_2_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 3, Arrow);
}
	   else {}
      }
      else if ((JOYPAD & J_A) && (SpriteX < 26 & SpriteY < 26))
      {

	   if (InvCheck == 2) {

	   if (ud == 3 && blip == 2) {
bing = 3;
blip = 9;
}
	   else {} 
         
}
	   else {
         ClearScreen(SCR_1_PLANE);
	   if (key == 2) { PrintString(SCR_1_PLANE, 0, 4, 9, "It's A Bed.");
         PrintString(SCR_1_PLANE, 0, 2, 10, "No Time To Rest."); }
 	   else if (bing == 3)  PrintString(SCR_1_PLANE, 0, 2, 6, "That won't work."); 
	   else { PrintString(SCR_1_PLANE, 0, 2, 9, "Picked up a Key.");
	   blip = 2; }

	}
      }

      else if (JOYPAD & J_A)
      {

	   if (InvCheck == 2) {

	   if (ud == 3 && blip == 2) {
bing = 3;
blip = 9;
}
	   else {} 
         
}
	   else {}
      }

	else if (JOYPAD & J_B) Inventory2();
      Sleep(3);
   }
}
int LevelOneReturn()
{
   ClearScreen(SCR_1_PLANE);
   ClearScreen(SCR_2_PLANE);
   
   PutTile(SCR_2_PLANE, 0, 2, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, 2, WallLeft);
   PutTile(SCR_2_PLANE, 0, 2, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 17, 2, WallRight);
   PutTile(SCR_2_PLANE, 0, 16, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, 16, WallLeft);
   PutTile(SCR_2_PLANE, 0, 17, 16, WallRight);
   PutTile(SCR_2_PLANE, 0, 1, 1, WallTopLeft);
   PutTile(SCR_2_PLANE, 0, 2, 1, BedTopLeft);
   PutTile(SCR_2_PLANE, 0, 1, 1, BedTopRight);
   PutTile(SCR_2_PLANE, 0, 1, 2, BedBottomLeft);
   PutTile(SCR_2_PLANE, 0, 2, 2, BedBottomRight);
   PutTile(SCR_2_PLANE, 0, 1, 17, WallBottomLeft);
   PutTile(SCR_2_PLANE, 0, 17, 1, WallTopRight);
   PutTile(SCR_2_PLANE, 0, 17, 17, WallBottomRight2);
   for(iLoop=3;iLoop<=15;iLoop++)
   {
   PutTile(SCR_2_PLANE, 0, iLoop, 1, WallTop);
   PutTile(SCR_2_PLANE, 0, 1, iLoop, WallLeft);
   PutTile(SCR_2_PLANE, 0, iLoop, 17, WallBottom);
   PutTile(SCR_2_PLANE, 0, 17, iLoop, WallRight);
   }

   // initialise Sprite variables
   SpriteX = 125;
   SpriteY = 124;
   SpriteAnim = 0;
   SpriteBaseAnim = 0;
   
   // set the initial sprite up
   // Note that all 4 sprites are chained together so we only have to
   // move the first one and the rest follow :-)
   SetSprite(SPR_SPRITE, TILE_SPRITE, 0, SpriteX, SpriteY, 0);
   SetSprite(SPR_SPRITE+1, TILE_SPRITE+1, 1, 8, 0, 0);
   SetSprite(SPR_SPRITE+2, TILE_SPRITE+2, 1, -8, 8, 0);
   SetSprite(SPR_SPRITE+3, TILE_SPRITE+3, 1, 8, 0, 0);

   while (1)
   {
      if ((JOYPAD & J_LEFT) && (SpriteX > 10))
      {
	   if (InvCheck == 2) { }
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 2) key = 2;
         CopySpriteAnim(16+(SpriteAnim * 4));
         SpriteX -= 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1; // toggles anim 0->1->0 }
	}
	}
      else if ((JOYPAD & J_RIGHT) && (SpriteX < 126))
      {
	   if (InvCheck == 2) {}
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 2) key = 2;
         CopySpriteAnim(24+(SpriteAnim * 4));
         SpriteX += 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
      }
	}
      else if ((JOYPAD & J_UP) && (SpriteY > 10))
      {
	   if (InvCheck == 2) {
   ud = 3;
   ClearScreen(SCR_2_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 2, Arrow);
}
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 2) key = 2;
         CopySpriteAnim(8+(SpriteAnim * 4));
         SpriteY -= 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
	}
      }
      else if ((JOYPAD & J_DOWN) && (SpriteY < 125))
      {
	   if (InvCheck == 2) {
   ud = 2;
   ClearScreen(SCR_2_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 3, Arrow);
}
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 1) key = 2;
         CopySpriteAnim(0+(SpriteAnim * 4));
         SpriteY += 2;
         SetSpritePosition(SPR_SPRITE, SpriteX, SpriteY);
         SpriteAnim ^= 1;
	}
      }
      else if ((JOYPAD & J_DOWN) && (SpriteY > 123 & SpriteX > 124))
      {
	   if (InvCheck == 2) {
   ud = 2;
   ClearScreen(SCR_2_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 3, Arrow);
}
	   else {
	   ClearScreen(SCR_1_PLANE);
	   if (blip == 1) key = 2;
	   LevelTwo();
	}
      }
      else if (JOYPAD & J_DOWN)
      {
	   if (InvCheck == 2) {
   ud = 2;
   ClearScreen(SCR_2_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 3, Arrow);
}
	   else {}
      }
      else if ((JOYPAD & J_A) && (SpriteX < 26 & SpriteY < 26))
      {

	   if (InvCheck == 2) {

	   if (ud == 3 && blip == 2) {
bing = 3;
blip = 9;
}

	   else {} 
         
}
	   else {
         ClearScreen(SCR_1_PLANE);
	   if (key == 2) { PrintString(SCR_1_PLANE, 0, 4, 9, "It's A Bed.");
         PrintString(SCR_1_PLANE, 0, 2, 10, "No Time To Rest."); }
 	   else if (bing == 3)  PrintString(SCR_1_PLANE, 0, 2, 6, "That won't work."); 
	   else { PrintString(SCR_1_PLANE, 0, 2, 9, "Picked up a Key.");
	   blip = 2; }

	}
      }

      else if (JOYPAD & J_A)
      {

	   if (InvCheck == 2) {

	   if (ud == 3 && blip == 2) {
bing = 3;
blip = 9;
}

	   else {} 
         
}
	   else {}
      }

	else if (JOYPAD & J_B) Inventory1();
      Sleep(3);
   }
}

int Inventory1()
{
   InvCheck = 2;
   ClearScreen(SCR_1_PLANE);
   ClearScreen(SCR_2_PLANE);
   ClearScreen(SPRITE_PLANE);
   PutTile(SCR_2_PLANE, 0, 1, 2, Arrow);
   SpriteX = 200;
   SpriteY = 200;
   SetSprite(SPR_SPRITE, TILE_SPRITE, 0, SpriteX, SpriteY, 0);
   PrintString(SCR_1_PLANE, 0, 4, 1, "Inventory");
   if (blip == 2) { PrintString(SCR_1_PLANE, 0, 2, 2, "Key");
PrintString(SCR_1_PLANE, 0, 2, 3, "Nothing"); }
   else PrintString(SCR_1_PLANE, 0, 2, 2, "Nothing");
   if (JOYPAD & J_B) {
   InvCheck = 1;
   LevelOne(); }
}

int Inventory2()
{
   InvCheck = 2;
   ClearScreen(SCR_1_PLANE);
   ClearScreen(SCR_2_PLANE);
   ClearScreen(SPRITE_PLANE);
   SpriteX = 200;
   SpriteY = 200;
   PutTile(SCR_2_PLANE, 0, 1, 1, Arrow);
   SetSprite(SPR_SPRITE, TILE_SPRITE, 0, SpriteX, SpriteY, 0);
   PrintString(SCR_1_PLANE, 0, 4, 1, "Inventory");
   if (blip == 2) PrintString(SCR_1_PLANE, 0, 4, 9, "Key");
   else PrintString(SCR_1_PLANE, 0, 4, 9, "Nothing");
   if (JOYPAD & J_B) {
   InvCheck = 1;
   LevelTwo(); }
}